initAmmo("paint","Paint",true)
lastX=null
lastY=null
lastZ=1
paintDabs = new Array()
initpaint()
paletteFrame=null
var brushSizeStartX
var brushSizeExample
var brushHelpWindow
try
{
	var paintPrefs = XMLDOM.parse(filesystem.readFile(system.widgetDataFolder + "/paint/prefs.xml"))
}
catch(e)
{
	alert("Unable to load Paint preferences.")
}

brushSize = parseInt(paintPrefs.evaluate("prefs/brushSize").item(0).firstChild.data)

function initpaint()
{

	for(ammoButton in beltFrame.subviews)
	{
		var ammoImageSrc=beltFrame.subviews[ammoButton].src
		if(ammoImageSrc.substr(ammoImageSrc.length-10)=="/paint.png")
		{
			beltFrame.subviews[ammoButton].onMouseDown+=";showPalette()"
		}
	}
}

function selectColor(idx)
{
	paintDabs[parseInt(paintPrefs.evaluate("prefs/selectedColor").item(0).firstChild.data)].src = system.widgetDataFolder + "/paint/paint" + parseInt(paintPrefs.evaluate("prefs/selectedColor").item(0).firstChild.data) + ".png"
	paintDabs[idx].src = system.widgetDataFolder + "/paint/paintHi" + idx + ".png"
	paintPrefs.evaluate("prefs/selectedColor").item(0).firstChild.data=idx
	filesystem.writeFile(system.widgetDataFolder + "/paint/prefs.xml", paintPrefs.toXML())
}

function changeColor(idx)
{
	var newColor = chooseColor(paintDabs[idx].colorize)
	if(newColor)
	{
		paintDabs[idx].colorize= newColor
		paintPrefs.evaluate("prefs/paint" + idx).item(0).firstChild.data = newColor
		filesystem.writeFile(system.widgetDataFolder + "/paint/prefs.xml", paintPrefs.toXML())
	}
}

function brushSizeFinish()
{
     brushSizeStartX=null
	brushSize=brushSizeExample.width
	paintPrefs.evaluate("prefs/brushSize").item(0).firstChild.data=brushSize
	filesystem.writeFile(system.widgetDataFolder + "/paint/prefs.xml", paintPrefs.toXML())
	brushSizeExample.visible=false
}

function brushSizeStart()
{
     brushSizeStartX=system.event.hOffset
	brushSizeExample = new Image()
	paletteFrame.addSubview(brushSizeExample)
	brushSizeExample.width=brushSize
	brushSizeExample.height=brushSize
	brushSizeExample.src = system.widgetDataFolder + "/paint/dot.png"
	brushSizeExample.colorize = "#000000"
	brushSizeExample.vOffset=95
	brushSizeExample.hOffset=40
}

function brushSizeChange()
{
	newSize = brushSize + (system.event.hOffset - brushSizeStartX)
	if(newSize < 1 || newSize > 100 || (newSize/2) != Math.round(newSize/2))
	{
		return
	}
	brushSizeExample.height=newSize
	brushSizeExample.width=newSize
}

function showPalette()
{
	if(paletteFrame == null)
	{
     	paletteFrame = new Frame()
     	win.addSubview(paletteFrame)
		paletteFrame.hOffset=parseInt(paintPrefs.evaluate("prefs/paletteX").item(0).firstChild.data)
		paletteFrame.vOffset=parseInt(paintPrefs.evaluate("prefs/paletteY").item(0).firstChild.data)
     	paletteFrame.zOrder = 999999
     	paletteFrame.onMouseMove = "movePalette()"
     	paletteFrame.onMouseUp = "savePaletteLoc()"
     	paletteFrame.onMouseDown = "paletteOffX = system.event.hOffset-paletteFrame.hOffset;paletteOffY = system.event.vOffset-paletteFrame.vOffset"
     	var tempImage = new Image()
     	paletteFrame.addSubview(tempImage)
     	tempImage.src = system.widgetDataFolder + "/paint/brushbottom.png"
     	var tempImage = new Image()
     	paletteFrame.addSubview(tempImage)
     	tempImage.src = system.widgetDataFolder + "/paint/palette.png"
     	var tempImage = new Image()
     	paletteFrame.addSubview(tempImage)
     	tempImage.src = system.widgetDataFolder + "/paint/brushtop.png"
     	tempImage.onMouseDown = "brushSizeStart()"
     	tempImage.onMouseMove = "brushSizeChange()"
     	tempImage.onMouseUp = "brushSizeFinish()"
     	for(var a=0;a<7;a++)
     	{
     		paintDabs[a] = new Image()
     		paletteFrame.addSubview(paintDabs[a])
			if(a==parseInt(paintPrefs.evaluate("prefs/selectedColor").item(0).firstChild.data))
			{
     			paintDabs[a].src = system.widgetDataFolder + "/paint/paintHi" + a + ".png"
			}
			else
			{
     			paintDabs[a].src = system.widgetDataFolder + "/paint/paint" + a + ".png"
			}
     		paintDabs[a].onMouseDown = "selectColor(" + a + ")"
			paintDabs[a].onMultiClick="changeColor(" + a + ")"
			if(paintPrefs.evaluate("prefs/paint" + a).item(0).firstChild != null)
			{
     			paintDabs[a].colorize = paintPrefs.evaluate("prefs/paint" + a).item(0).firstChild.data
			}
     	}
		var tempImage = new Image()
     	paletteFrame.addSubview(tempImage)
     	tempImage.src = system.widgetDataFolder + "/paint/help.png"
     	tempImage.onMouseDown = "paintHelp()"
	}
}

function paintHelp()
{
	if(brushHelpWindow == null)
	{
     	brushHelpWindow = new Image()
          paletteFrame.addSubview(brushHelpWindow)
          brushHelpWindow.src = system.widgetDataFolder + "/paint/helpwindow.png"
     	brushHelpWindow.onMouseDown = "brushHelpWindow.visible=false"
	}
	else
	{
		brushHelpWindow.visible=true
	}
}

function movePalette()
{
     paletteFrame.hOffset = system.event.hOffset-paletteOffX//-(paletteFrame.width/2)
     paletteFrame.vOffset = system.event.vOffset-paletteOffY//-(paletteFrame.height/2)
}

function savePaletteLoc()
{
	paintPrefs.evaluate("prefs/paletteX").item(0).firstChild.data=paletteFrame.hOffset
	paintPrefs.evaluate("prefs/paletteY").item(0).firstChild.data=paletteFrame.vOffset
	filesystem.writeFile(system.widgetDataFolder + "/paint/prefs.xml", paintPrefs.toXML())
	paletteStartX=null
	paletteStartY=null
}

function paintaction(mouseAction)
{
	switch(mouseAction)
	{
		case "Down":
			lastX=system.event.hOffset
			lastY=system.event.vOffset
			if(brushSize>2)
			{
     			var paintImg = new Image()
          		win.addSubview(paintImg)
     			paintImg.hOffset=lastX-(brushSize/2)
     			paintImg.vOffset=lastY-(brushSize/2)
     			paintImg.width=brushSize
     			paintImg.height=brushSize
          		paintImg.src =system.widgetDataFolder + "/paint/dot.png"
     			paintImg.colorize=paintPrefs.evaluate("prefs/paint" + parseInt(paintPrefs.evaluate("prefs/selectedColor").item(0).firstChild.data)).item(0).firstChild.data
			}

		case "Move":
			w=lastX-system.event.hOffset
			h=lastY-system.event.vOffset
			d=Math.sqrt((w*w)+(h*h))
			a = Math.atan(h / w) * 180 / Math.PI
			var paintImg = new Image()
     		win.addSubview(paintImg)
     		
     		paintImg.src =system.widgetDataFolder + "/paint/pixel.png"
			paintImg.zOrder = lastZ-1
			paintImg.colorize=paintPrefs.evaluate("prefs/paint" + parseInt(paintPrefs.evaluate("prefs/selectedColor").item(0).firstChild.data)).item(0).firstChild.data
			if(d<1)
			{
				d=1
			}
			
    			paintImg.height=brushSize
			paintImg.vRegistrationPoint = paintImg.height/2
     		paintImg.width=d

			if(system.event.hOffset <= lastX)
			{
	    			paintImg.vOffset = system.event.vOffset
	    			paintImg.hOffset = system.event.hOffset
			}
			else
			{
		     	paintImg.hOffset = lastX
	     		paintImg.vOffset = lastY
			}
			paintImg.rotation = a
			if(brushSize>2)
			{
     			var paintImg = new Image()
          		win.addSubview(paintImg)
     			paintImg.hOffset=system.event.hOffset-(brushSize/2)
     			paintImg.vOffset=system.event.vOffset-(brushSize/2)
     			paintImg.width=brushSize
     			paintImg.height=brushSize
          		paintImg.src =system.widgetDataFolder + "/paint/dot.png"
     			paintImg.colorize=paintPrefs.evaluate("prefs/paint" + parseInt(paintPrefs.evaluate("prefs/selectedColor").item(0).firstChild.data)).item(0).firstChild.data
				lastZ=paintImg.zOrder
			}
			lastX=system.event.hOffset
			lastY=system.event.vOffset
	}
}

function paintreset()
{
	paletteFrame = null
	brushHelpWindow = null
}